unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, ComCtrls, Buttons, SDL_Colsel, SDL_rchart, SDL_dendrogram,
  SDL_NumLab;

type
  TForm1 = class(TForm)
    ButNewData: TButton;
    RGOrientation: TRadioGroup;
    RChart1: TRChart;
    SBarHigh: TScrollBar;
    CSelScale: TColSel;
    MyDendro: TDendrogram;
    CSelDendro: TColSel;
    CSelDendroBG: TColSel;
    CSelScaleBG: TColSel;
    SBarHorzScaleWid: TScrollBar;
    RGDistMode: TRadioGroup;
    RGClustMeth: TRadioGroup;
    SBarAlpha: TScrollBar;
    PopMenDendro: TPopupMenu;
    Zoom111: TMenuItem;
    Pan1: TMenuItem;
    ZoomWindow1: TMenuItem;
    ZoombyMouseDrag1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LblScaleWidth: TLabel;
    SBarMargin: TScrollBar;
    Label6: TLabel;
    DragCrosshair1: TMenuItem;
    ProgressBar1: TProgressBar;
    Label8: TLabel;
    BButExit: TBitBtn;
    Copy1: TMenuItem;
    toClipBoard1: TMenuItem;
    toBMPFile1: TMenuItem;
    CBoxClassColors: TCheckBox;
    AssignClassesatCrosshairPosition1: TMenuItem;
    Label9: TLabel;
    CSelLblBg: TColSel;
    Label10: TLabel;
    CSelEmptyArea: TColSel;
    FontDiag: TFontDialog;
    BButSelFont: TBitBtn;
    SButZoom11: TSpeedButton;
    SButPan: TSpeedButton;
    SButZoomWind: TSpeedButton;
    SButZoomDrag: TSpeedButton;
    SButDragCrossh: TSpeedButton;
    CBoxForceStaggered: TCheckBox;
    SDiag: TSaveDialog;
    NLabCrossHX: TNumLab;
    NLabCrossHY: TNumLab;
    Button1: TButton;
    procedure ButNewDataClick(Sender: TObject);
    procedure RGOrientationClick(Sender: TObject);
    procedure SBarHighChange(Sender: TObject);
    procedure CSelScaleChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CSelDendroChange(Sender: TObject);
    procedure CSelDendroBGChange(Sender: TObject);
    procedure CSelScaleBGChange(Sender: TObject);
    procedure SBarHorzScaleWidChange(Sender: TObject);
    procedure SBarMarginChange(Sender: TObject);
    procedure RGDistModeClick(Sender: TObject);
    procedure RGClustMethClick(Sender: TObject);
    procedure SBarAlphaChange(Sender: TObject);
    procedure Zoom111Click(Sender: TObject);
    procedure Pan1Click(Sender: TObject);
    procedure ZoomWindow1Click(Sender: TObject);
    procedure ZoombyMouseDrag1Click(Sender: TObject);
    procedure DragCrosshair1Click(Sender: TObject);
    procedure MyDendroProgress(Sender: TObject; PercentDone: Integer);
    procedure MyDendroCalcDistance(Sender: TObject; Row1, Row2: Integer;
      var Distance: Double);
    procedure BButExitClick(Sender: TObject);
    procedure toClipBoard1Click(Sender: TObject);
    procedure toBMPFile1Click(Sender: TObject);
    procedure CBoxClassColorsClick(Sender: TObject);
    procedure AssignClassesatCrosshairPosition1Click(Sender: TObject);
    procedure CSelEmptyAreaChange(Sender: TObject);
    procedure CSelLblBgChange(Sender: TObject);
    procedure BButSelFontClick(Sender: TObject);
    procedure CBoxForceStaggeredClick(Sender: TObject);
    procedure MyDendroBeforeShowObjLabel(Sender: TObject; Obj: Integer;
      var Text: String; var Color: TColor);
    procedure MyDendroCrossHairMove(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FullDist : double;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  SDL_sdlbase, SDL_matrix, SDL_math2, SDL_datatable;

const
  NCols = 2;
  NRowsHalf = 30;


(******************************************************************************)
procedure TForm1.ButNewDataClick(Sender: TObject);
(******************************************************************************)

var
  i,j : integer;

begin
Randomize;
MyDendro.SuppressClustAnal := true;
MyDendro.Data.Resize(NCols,2*NRowsHalf);
for j:=1 to NRowsHalf do
  begin
  MyDendro.Data.RowName[j] := 'R'+IntToStr(j);
  MyDendro.Data.RowAttrib[j] := 1;
  for i:=1 to NCols do
    MyDendro.Data[i,j] := 10+random(100);
  end;
for j:=NRowsHalf+1 to 2*NRowsHalf do
  begin
  MyDendro.Data.RowName[j] := 'S'+IntToStr(j);
  MyDendro.Data.RowAttrib[j] := 2;
  for i:=1 to NCols do
    MyDendro.Data[i,j] := 140+random(100);
  end;
MyDendro.SuppressClustAnal := false;
RChart1.ClearGraf;    // display data
for i:=1 to NRowsHalf*2 do
  RChart1.Text (MyDendro.Data.NumericData[1,i], MyDendro.Data.NumericData[2,i], 8, IntToStr(i));
RChart1.ShowGraf;
ProgressBar1.Position := 0;
MyDendro.AutoRange;
FullDist := MyDendro.DistHigh;
SBarHigh.Position := 100;
end;

(******************************************************************************)
procedure TForm1.RGOrientationClick(Sender: TObject);
(******************************************************************************)

begin
MyDendro.Orientation := TDirection(RGOrientation.ItemIndex);
if (MyDendro.Orientation = dirLeftWard) or (MyDendro.Orientation = dirRightWard)
  then begin
       SBarHorzScaleWid.Position := MyDendro.ScaleWidth;
       LblScaleWidth.Caption := 'Height of Scale';
       CBoxForceStaggered.Enabled := false;
       end
  else begin
       SBarHorzScaleWid.Position := MyDendro.ScaleHeight;
       LblScaleWidth.Caption := 'Width of Scale';
       CBoxForceStaggered.Enabled := true;
       end;
end;


(******************************************************************************)
procedure TForm1.SBarHighChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.SetRange (0, NRowsHalf*2+1, 0, SBarHigh.Position/100*FullDist);
end;

(******************************************************************************)
procedure TForm1.CSelScaleChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ColorScale := CSelScale.SelColor;
end;

(******************************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(******************************************************************************)

begin
ButNewDataClick (Sender);
CBoxForceStaggered.Enabled := FontIsTrueType (MyDendro.Font.Name);
MyDendro.OnBeforeShowObjLabel := MyDendroBeforeShowObjLabel;
end;

(******************************************************************************)
procedure TForm1.CSelDendroChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ColorDendrogram := CSelDendro.SelColor;
end;

(******************************************************************************)
procedure TForm1.CSelDendroBGChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ColorDendrogramBackGnd := CSelDendroBG.SelColor;
end;

(******************************************************************************)
procedure TForm1.CSelScaleBGChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ColorScaleBackGnd := CSelScaleBG.SelColor;
end;

(******************************************************************************)
procedure TForm1.SBarHorzScaleWidChange(Sender: TObject);
(******************************************************************************)

begin
if (MyDendro.Orientation = dirLeftWard) or (MyDendro.Orientation = dirRightWard)
  then MyDendro.ScaleWidth := SBarHorzScaleWid.Position
  else MyDendro.ScaleHeight := SBarHorzScaleWid.Position;
end;

(******************************************************************************)
procedure TForm1.RGDistModeClick(Sender: TObject);
(******************************************************************************)

begin
MyDendro.DistMeasure := TDistMode(RGDistMode.ItemIndex);
MyDendro.AutoRange;
FullDist := MyDendro.DistHigh;
SBarHigh.Position := 100;
ProgressBar1.Position := 0;
end;

(******************************************************************************)
procedure TForm1.RGClustMethClick(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ClusterMethod := TClusterMethod(RGClustMeth.ItemIndex);
MyDendro.AutoRange;
FullDist := MyDendro.DistHigh;
SBarHigh.Position := 100;
ProgressBar1.Position := 0;
end;

(******************************************************************************)
procedure TForm1.SBarAlphaChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.SuppressPaint := true;
MyDendro.FlexAlpha := SBarAlpha.Position/100;
MyDendro.AutoRange;
FullDist := MyDendro.DistHigh;
SBarHigh.Position := 100;
MyDendro.SuppressPaint := false;
ProgressBar1.Position := 0;
end;


(******************************************************************************)
procedure TForm1.Zoom111Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.AutoRange;
end;

(******************************************************************************)
procedure TForm1.Pan1Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.MouseAction := maPan;
end;

(******************************************************************************)
procedure TForm1.ZoomWindow1Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.MouseAction := maZoomWind;
end;


(******************************************************************************)
procedure TForm1.ZoombyMouseDrag1Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.MouseAction := maZoomDrag;
end;


(******************************************************************************)
procedure TForm1.SBarMarginChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.Margin := SBarMargin.Position;
end;


(******************************************************************************)
procedure TForm1.DragCrosshair1Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.MouseAction := maDragCrossH;
end;


(******************************************************************************)
procedure TForm1.MyDendroProgress(Sender: TObject; PercentDone: Integer);
(******************************************************************************)

begin
ProgressBar1.Position := PercentDone;
end;


(******************************************************************************)
procedure TForm1.MyDendroCalcDistance(Sender: TObject; Row1, Row2: Integer;
  var Distance: Double);
(******************************************************************************)

begin
Distance := abs(TMatrix(Sender).elem[1,Row1]-TMatrix(Sender).elem[1,Row2]);
end;

(******************************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(******************************************************************************)

begin
close;
end;

(******************************************************************************)
procedure TForm1.toClipBoard1Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.CopyToClipboard(false);
end;

(******************************************************************************)
procedure TForm1.toBMPFile1Click(Sender: TObject);
(******************************************************************************)

begin
if SDiag.Execute then
  MyDendro.CopyToBMP (SDiag.FileName, true);
end;

(******************************************************************************)
procedure TForm1.CBoxClassColorsClick(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ShowClassColors := CBoxClassColors.Checked;
end;

(******************************************************************************)
procedure TForm1.AssignClassesatCrosshairPosition1Click(Sender: TObject);
(******************************************************************************)

begin
MyDendro.CalcClasses(MyDendro.CrossHair.PosY);
MyDendro.ShowClassColors := true;
CBoxClassColors.Checked := true;
CBoxClassColors.Enabled := true;
end;

(******************************************************************************)
procedure TForm1.CSelEmptyAreaChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ColorEmptyArea := CSelEmptyArea.SelColor;
end;

(******************************************************************************)
procedure TForm1.CSelLblBgChange(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ColorLabelsBG := CSelLblBg.SelColor;
end;


(******************************************************************************)
procedure TForm1.BButSelFontClick(Sender: TObject);
(******************************************************************************)

begin
if FontDiag.Execute then
  begin
  MyDendro.Font := FontDiag.Font;
  CBoxForceStaggered.Enabled := FontIsTrueType (MyDendro.Font.Name);
  end;
end;

(******************************************************************************)
procedure TForm1.CBoxForceStaggeredClick(Sender: TObject);
(******************************************************************************)

begin
MyDendro.ForceStaggeredLabels := CBoxForceStaggered.Checked;
end;


(******************************************************************************)
procedure TForm1.MyDendroBeforeShowObjLabel(Sender: TObject; Obj: Integer;
  var Text: String; var Color: TColor);
(******************************************************************************)

begin
Text := MyDendro.Data.RowName[obj];
if Obj = MyDendro.MarkedObject then
  Color := clRed;
end;

(******************************************************************************)
procedure TForm1.MyDendroCrossHairMove(Sender: TObject);
(******************************************************************************)

var
  obj   : integer;
  astr  : string;

begin
obj := MyDendro.FindObject(round(MyDendro.CrossHair.PosX));
astr := '(none)';
if obj <> 0 then
  astr := MyDendro.Data.RowName[obj];
NLabCrossHX.StateText := astr;
NLabCrossHY.Value := MyDendro.CrossHair.PosY;
MyDendro.MarkedObject := obj;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
MyDendro.Data.ExportAsCSV('c:\temp\dendro.asc', 2, csvSemicolon, true, true, true);
end;

end.
